Skip to content
Back to top
View this page
Edit this page

# superduper.group

Handling groups

## Classes

`Bookmarks` | This is instantiated once per `BaseSession`
`MUC` | A room, a.k.a. a Multi-User Chat.
`Participant` | A legacy participant of a legacy group chat.

## Module Contents

class superduper.group.Bookmarks(session)

  This is instantiated once per `BaseSession`

  Parameters:

    session (slidge.core.session.BaseSession)

  async fill()

    Establish a user’s known groups.

    This has to be overridden in plugins with group support and at the minimum, this should `await self.by_legacy_id(group_id)` for all the groups a user is part of.

    Slidge internals will call this on successful `BaseSession.login()`

  async legacy_id_to_jid_username(legacy_id)

    The default implementation calls `str()` on the legacy_id and escape characters according to XEP-0106.

    You can override this class and implement a more subtle logic to raise an `XMPPError` early

    Parameters:

      legacy_id (slidge.util.types.LegacyGroupIdType)

    Returns:

    Return type:

      str

  async jid_username_to_legacy_id(username)
    Parameters:

      username (str)

    Returns:

  async remove(muc, reason='You left this group from the official client.', kick=True)

    Delete everything about a specific group.

    This should be called when the user leaves the group from the official app.

    Parameters:

      - muc (slidge.group.room.LegacyMUC) – The MUC to remove.

      - reason (str) – Optionally, a reason why this group was removed.

      - kick (bool) – Whether the user should be kicked from this group. Set this to False in case you do this somewhere else in your code, eg, on receiving the confirmation that the group was deleted.

    Return type:

      None

class superduper.group.MUC(session, stored)

  A room, a.k.a. a Multi-User Chat.

  MUC instances are obtained by calling `slidge.group.bookmarks.LegacyBookmarks()` on the user’s `slidge.core.session.BaseSession`.

  Parameters:

    - session (slidge.core.session.BaseSession)

    - stored (slidge.db.models.Room)

  async update_info()

    Fetch information about this group from the legacy network

    This is awaited on MUC instantiation, and should be overridden to update the attributes of the group chat, like title, subject, number of participants etc.

    To take advantage of the slidge avatar cache, you can check the .avatar property to retrieve the “legacy file ID” of the cached avatar. If there is no change, you should not call `slidge.core.mixins.avatar.AvatarMixin.set_avatar()` or attempt to modify the :attr:.avatar property.

  async fill_participants()

    This method should yield the list of all members of this group.

    Typically, use `participant = self.get_participant()`, self.get_participant_by_contact(), of self.get_user_participant(), and update their affiliation, hats, etc. before yielding them.

  async backfill(after=None, before=None)

    Override this if the legacy network provide server-side group archives.

    In it, send history messages using `self.get_participant(xxx).send_xxxx`, with the `archive_only=True` kwarg. This is only called once per slidge run for a given group.

    Parameters:

      - after (Optional[slidge.util.types.HoleBound]) – Fetch messages after this one. If `None`, it’s up to you to decide how far you want to go in the archive. If it’s not `None`, it means slidge has some messages in this archive and you should really try to complete it to avoid “holes” in the history of this group.

      - before (Optional[slidge.util.types.HoleBound]) – Fetch messages before this one. If `None`, fetch all messages up to the most recent one

  STABLE_ARCHIVE = False

    Because legacy events like reactions, editions, etc. don’t all map to a stanza with a proper legacy ID, slidge usually cannot guarantee the stability of the archive across restarts.

    Set this to True if you know what you’re doing, but realistically, this can’t be set to True until archive is permanently stored on disk by slidge.

    This is just a flag on archive responses that most clients ignore anyway.

  HAS_DESCRIPTION = True

    Set this to false if the legacy network does not allow setting a description for the group. In this case the description field will not be present in the room configuration form.

  HAS_SUBJECT = True

    Set this to false if the legacy network does not allow setting a subject (sometimes also called topic) for the group. In this case, as a subject is recommended by XEP-0045 (“SHALL”), the description (or the group name as ultimate fallback) will be used as the room subject. By setting this to false, an error will be returned when the User tries to set the room subject.

  pop_unread_xmpp_ids_up_to(horizon_xmpp_id)

    Return XMPP msg ids sent in this group up to a given XMPP msg id.

    Plugins have no reason to use this, but it is used by slidge core for legacy networks that need to mark all messages as read (most XMPP clients only send a read marker for the latest message).

    This has side effects: all messages up to the horizon XMPP id will be marked as read in the DB. If the horizon XMPP id is not found, all messages of this MUC will be marked as read.

    Parameters:

      horizon_xmpp_id (str) – The latest message

    Returns:

      A list of XMPP ids if horizon_xmpp_id was not found

    Return type:

      list[str]

  async get_user_participant(**kwargs)

    Get the participant representing the gateway user

    Parameters:

      kwargs – additional parameters for the `Participant` construction (optional)

    Returns:

    Return type:

      slidge.util.types.LegacyParticipantType

  async get_participant(nickname: str) → slidge.util.types.LegacyParticipantType
  async get_participant(*, occupant_id: str) → slidge.util.types.LegacyParticipantType
  async get_participant(*, occupant_id: str, create: Literal[False]) → LegacyParticipantType | None
  async get_participant(*, occupant_id: str, create: Literal[True]) → slidge.util.types.LegacyParticipantType
  async get_participant(nickname: str, *, occupant_id: str) → slidge.util.types.LegacyParticipantType
  async get_participant(nickname: str, *, create: Literal[False]) → LegacyParticipantType | None
  async get_participant(nickname: str, *, create: Literal[True]) → slidge.util.types.LegacyParticipantType
  async get_participant(nickname: str, *, create: Literal[True], is_user: bool, fill_first: bool, store: bool) → slidge.util.types.LegacyParticipantType
  async get_participant(nickname: str, *, create: Literal[False], is_user: bool, fill_first: bool, store: bool) → LegacyParticipantType | None
  async get_participant(nickname: str, *, create: bool, fill_first: bool) → LegacyParticipantType | None

    Get a participant by their nickname.

    In non-anonymous groups, you probably want to use `LegacyMUC.get_participant_by_contact()` instead.

    Parameters:

      - nickname – Nickname of the participant (used as resource part in the MUC)

      - create – By default, a participant is created if necessary. Set this to False to return None if participant was not created before.

      - is_user – Whether this participant is the slidge user.

      - fill_first – Ensure `LegacyMUC.fill_participants()` has been called first (internal use by slidge, plugins should not need that)

      - store – persistently store the user in the list of MUC participants

      - occupant_id – optionally, specify the unique ID for this participant, cf xep:0421

    Returns:

      A participant of this room.

  get_system_participant()

    Get a pseudo-participant, representing the room itself

    Can be useful for events that cannot be mapped to a participant, e.g. anonymous moderation events, or announces from the legacy service :return:

    Return type:

      slidge.util.types.LegacyParticipantType

  async get_participant_by_contact(c: LegacyContact[Any]) → slidge.util.types.LegacyParticipantType
  async get_participant_by_contact(c: LegacyContact[Any], *, occupant_id: str | None = None) → slidge.util.types.LegacyParticipantType
  async get_participant_by_contact(c: LegacyContact[Any], *, create: Literal[False], occupant_id: str | None) → LegacyParticipantType | None
  async get_participant_by_contact(c: LegacyContact[Any], *, create: Literal[True], occupant_id: str | None) → slidge.util.types.LegacyParticipantType

    Get a non-anonymous participant.

    This is what should be used in non-anonymous groups ideally, to ensure that the Contact jid is associated to this participant

    Parameters:

      - c – The `LegacyContact` instance corresponding to this contact

      - create – Creates the participant if it does not exist.

      - occupant_id – Optionally, specify a unique occupant ID (XEP-0421) for this participant.

    Returns:

  remove_participant(p, kick=False, ban=False, reason=None)

    Call this when a participant leaves the room

    Parameters:

      - p (slidge.util.types.LegacyParticipantType) – The participant

      - kick (bool) – Whether the participant left because they were kicked

      - ban (bool) – Whether the participant left because they were banned

      - reason (str | None) – Optionally, a reason why the participant was removed.

  async kick_resource(r)

    Kick a XMPP client of the user. (slidge internal use)

    Parameters:

      r (str) – The resource to kick

    Return type:

      None

  async add_to_bookmarks(auto_join=True, preserve=True, pin=None, notify=None)

    Add the MUC to the user’s XMPP bookmarks (:xep:`0402’)

    This requires that slidge has the IQ privileged set correctly on the XMPP server

    Parameters:

      - auto_join (bool) – whether XMPP clients should automatically join this MUC on startup. In theory, XMPP clients will receive a “push” notification when this is called, and they will join if they are online.

      - preserve (bool) – preserve auto-join and bookmarks extensions set by the user outside slidge

      - pin (bool | None) – Pin the group chat bookmark XEP-0469. Requires privileged entity. If set to `None` (default), the bookmark pinning status will be untouched.

      - notify (slixmpp.plugins.xep_0492.stanza.WhenLiteral | None) – Chat notification setting: XEP-0492. Requires privileged entity. If set to `None` (default), the setting will be untouched. Only the “global” notification setting is supported (ie, per client type is not possible).

    Return type:

      None

  abstractmethod on_avatar(data, mime)
    Async:

    Parameters:

      - data (Optional[bytes])

      - mime (Optional[str])

    Return type:

      Optional[Union[int, str]]

    Called when the user tries to set the avatar of the room from an XMPP client.

    If the set avatar operation is completed, should return a legacy image unique identifier. In this case the MUC avatar will be immediately updated on the XMPP side.

    If data is not None and this method returns None, then we assume that self.set_avatar() will be called elsewhere, eg triggered by a legacy room update event.

    Parameters:

      - data (Optional[bytes]) – image data or None if the user meant to remove the avatar

      - mime (Optional[str]) – the mime type of the image. Since this is provided by the XMPP client, there is no guarantee that this is valid or correct.

    Returns:

      A unique avatar identifier, which will trigger `slidge.group.room.LegacyMUC.set_avatar()`. Alternatively, None, if `LegacyMUC.set_avatar()` is meant to be awaited somewhere else.

    Return type:

      Optional[Union[int, str]]

  abstractmethod on_set_affiliation(contact, affiliation, reason, nickname)
    Async:

    Parameters:

      - contact (slidge.contact.contact.LegacyContact)

      - affiliation (slidge.util.types.MucAffiliation)

      - reason (Optional[str])

      - nickname (Optional[str])

    Triggered when the user requests changing the affiliation of a contact for this group.

    Examples: promotion them to moderator, ban (affiliation=outcast).

    Parameters:

      - contact (slidge.contact.contact.LegacyContact) – The contact whose affiliation change is requested

      - affiliation (slidge.util.types.MucAffiliation) – The new affiliation

      - reason (Optional[str]) – A reason for this affiliation change

      - nickname (Optional[str])

  abstractmethod on_kick(contact, reason)
    Async:

    Parameters:

      - contact (slidge.contact.contact.LegacyContact)

      - reason (Optional[str])

    Triggered when the user requests changing the role of a contact to “none” for this group. Action commonly known as “kick”.

    Parameters:

      - contact (slidge.contact.contact.LegacyContact) – Contact to be kicked

      - reason (Optional[str]) – A reason for this kick

  abstractmethod on_set_config(name, description)
    Async:

    Parameters:

      - name (Optional[str])

      - description (Optional[str])

    Triggered when the user requests changing the room configuration. Only title and description can be changed at the moment.

    The legacy module is responsible for updating `title` and/or `description` of this instance.

    If `HAS_DESCRIPTION` is set to False, description will always be `None`.

    Parameters:

      - name (Optional[str]) – The new name of the room.

      - description (Optional[str]) – The new description of the room.

  abstractmethod on_destroy_request(reason)
    Async:

    Parameters:

      reason (Optional[str])

    Triggered when the user requests room destruction.

    Parameters:

      reason (Optional[str]) – Optionally, a reason for the destruction

  abstractmethod on_set_subject(subject)
    Async:

    Parameters:

      subject (str)

    Return type:

      None

    Triggered when the user requests changing the room subject.

    The legacy module is responsible for updating `subject` of this instance.

    Parameters:

      subject (str) – The new subject for this room.

    Return type:

      None

  abstractmethod on_set_thread_subject(thread, subject)
    Async:

    Parameters:

      - thread (slidge.util.types.LegacyThreadType)

      - subject (str)

    Return type:

      None

    Triggered when the user requests changing the subject of a specific thread.

    Parameters:

      - thread (slidge.util.types.LegacyThreadType) – Legacy identifier of the thread

      - subject (str) – The new subject for this thread.

    Return type:

      None

  get_archived_messages(msg_id)

    Query the slidge archive for messages sent in this group

    Parameters:

      msg_id (slidge.util.types.LegacyMessageType | str) – Message ID of the message in question. Can be either a legacy ID or an XMPP ID.

    Returns:

      Iterator over messages. A single legacy ID can map to several messages, because of multi-attachment messages.

    Return type:

      Iterator[slidge.util.archive_msg.HistoryMessage]

  property avatar: slidge.util.types.Avatar | None

    This property can be used to set or unset the avatar.

    Unlike the awaitable :method:`.set_avatar`, it schedules the update for later execution and is not blocking

    Return type:

      slidge.util.types.Avatar | None

  async set_avatar(avatar=None, delete=False)

    Set an avatar for this entity

    Parameters:

      - avatar (slidge.util.types.Avatar | pathlib.Path | str | None) – The avatar. Should ideally come with a legacy network-wide unique ID

      - delete (bool) – If the avatar is provided as a Path, whether to delete it once used or not.

    Return type:

      None

  serialize_extra_attributes()

    If you want custom attributes of your instance to be stored persistently to the DB, here is where you have to return them as a dict to be used in deserialize_extra_attributes().

    Return type:

      dict | None

  deserialize_extra_attributes(data)

    This is where you get the dict that you passed in serialize_extra_attributes().

    ⚠ Since it is serialized as json, dictionary keys are converted to strings! Be sure to convert to other types if necessary.

    Parameters:

      data (dict)

    Return type:

      None

  async available_emojis(legacy_msg_id=None)

    Override this to restrict the subset of reactions this recipient can handle.

    Returns:

      A set of emojis or None if any emoji is allowed

    Parameters:

      legacy_msg_id (Optional[slidge.util.types.LegacyMessageType])

    Return type:

      Optional[set[str]]

class superduper.group.Participant(muc, stored, is_system=False, contact=None)

  A legacy participant of a legacy group chat.

  Parameters:

    - muc (slidge.group.room.LegacyMUC)

    - stored (slidge.db.models.Participant)

    - is_system (bool)

    - contact (slidge.contact.LegacyContact[Any] | None)

  send_initial_presence(full_jid, nick_change=False, presence_id=None)

    Called when the user joins a MUC, as a mechanism to indicate to the joining XMPP client the list of “participants”.

    Can be called this to trigger a “participant has joined the group” event.

    Parameters:

      - full_jid (slixmpp.JID) – Set this to only send to a specific user XMPP resource.

      - nick_change (bool) – Used when the user joins and the MUC renames them (code 210)

      - presence_id (Optional[str]) – set the presence ID. used internally by slidge

    Return type:

      None

  leave()

    Call this when the participant leaves the room

    Return type:

      None

  kick(reason=None)

    Call this when the participant is kicked from the room

    Parameters:

      reason (str | None)

    Return type:

      None

  ban(reason=None)

    Call this when the participant is banned from the room

    Parameters:

      reason (str | None)

    Return type:

      None

  online(status=None, last_seen=None)

    Send an “online” presence from this contact to the user.

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Listening to Britney Spears”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  away(status=None, last_seen=None)

    Send an “away” presence from this contact to the user.

    This is a global status, as opposed to `LegacyContact.inactive()` which concerns a specific conversation, ie a specific “chat window”

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Gone to fight capitalism”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  extended_away(status=None, last_seen=None)

    Send an “extended away” presence from this contact to the user.

    This is a global status, as opposed to `LegacyContact.inactive()` which concerns a specific conversation, ie a specific “chat window”

    Parameters:

      - status (Optional[str]) – Arbitrary text, details of the status, eg: “Gone to fight capitalism”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  busy(status=None, last_seen=None)

    Send a “busy” (ie, “dnd”) presence from this contact to the user,

    Parameters:

      - status (Optional[str]) – eg: “Trying to make sense of XEP-0100”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  offline(status=None, last_seen=None)

    Send an “offline” presence from this contact to the user.

    Parameters:

      - status (Optional[str]) – eg: “Trying to make sense of XEP-0100”

      - last_seen (Optional[datetime.datetime]) – For XEP-0319

    Return type:

      None

  invite_to(muc, reason=None, password=None, **send_kwargs)

    Send an invitation to join a group (XEP-0249) from this XMPP Entity.

    Parameters:

      - muc (slidge.group.LegacyMUC) – the muc the user is invited to

      - reason (Optional[str]) – a text explaining why the user should join this muc

      - password (Optional[str]) – maybe this will make sense later? not sure

      - send_kwargs – additional kwargs to be passed to _send() (internal use by slidge)

    Return type:

      None

  active(**kwargs)

    Send an “active” chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  composing(**kwargs)

    Send a “composing” (ie “typing notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  paused(**kwargs)

    Send a “paused” (ie “typing paused notification”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  inactive(**kwargs)

    Send an “inactive” (ie “contact has not interacted with the chat session interface for an intermediate period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  gone(**kwargs)

    Send a “gone” (ie “contact has not interacted with the chat session interface, system, or device for a relatively long period of time”) chat state (XEP-0085) from this XMPP Entity.

    Return type:

      None

  ack(legacy_msg_id, **kwargs)

    Send an “acknowledged” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  received(legacy_msg_id, **kwargs)

    Send a “received” message marker (XEP-0333) from this XMPP Entity. If called on a `LegacyContact`, also send a delivery receipt marker (XEP-0184).

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  displayed(legacy_msg_id, **kwargs)

    Send a “displayed” message marker (XEP-0333) from this XMPP Entity.

    Parameters:

      legacy_msg_id (slidge.util.types.LegacyMessageType) – The message this marker refers to

    Return type:

      None

  async send_file(attachment, legacy_msg_id=None, *, reply_to=None, when=None, thread=None, **kwargs)

    Send a single file from this XMPP Entity.

    Parameters:

      - attachment (slidge.util.types.LegacyAttachment | pathlib.Path | str) – The file to send. Ideally, a `LegacyAttachment` with a unique `legacy_file_id` attribute set, to optimise potential future reuses. It can also be: - a `pathlib.Path` instance to point to a local file, or - a `str`, representing a fetchable HTTP URL.

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - when (Optional[datetime.datetime]) – when the file was sent, for a “delay” tag (XEP-0203)

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      tuple[Optional[str], list[slixmpp.Message]]

  send_text(body, legacy_msg_id=None, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Send a text message from this XMPP Entity.

    Parameters:

      - body (str) – Content of the message

      - legacy_msg_id (Optional[slidge.util.types.LegacyMessageType]) – If you want to be able to transport read markers from the gateway user to the legacy network, specify this

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only used if called on a `LegacyContact`) Set this to `True` if this is actually a message sent to the `LegacyContact` by the User. Use this to synchronize outgoing history for legacy official apps.

      - correction (bool) – whether this message is a correction or not

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

  correct(legacy_msg_id, new_text, *, when=None, reply_to=None, thread=None, hints=None, carbon=False, archive_only=False, correction_event_id=None, link_previews=None, **send_kwargs)

    Modify a message that was previously sent by this XMPP Entity.

    Uses last message correction (XEP-0308)

    Parameters:

      - new_text (str) – New content of the message

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The legacy message ID of the message to correct

      - when (Optional[datetime.datetime]) – when the message was sent, for a “delay” tag (XEP-0203)

      - reply_to (Optional[slidge.util.types.MessageReference]) – Quote another message (XEP-0461)

      - hints (Optional[Iterable[slidge.util.types.ProcessingHint]])

      - thread (Optional[slidge.util.types.LegacyThreadType])

      - carbon (bool) – (only in 1:1) Reflect a message sent to this `Contact` by the user. Use this to synchronize outgoing history for legacy official apps.

      - archive_only (bool) – (only in groups) Do not send this message to user, but store it in the archive. Meant to be used during `MUC.backfill()`

      - correction_event_id (Optional[slidge.util.types.LegacyMessageType]) – in the case where an ID is associated with the legacy ‘correction event’, specify it here to use it on the XMPP side. If not specified, a random ID will be used.

      - link_previews (Optional[list[slidge.util.types.LinkPreview]]) – A little of sender (or server, or gateway)-generated previews of URLs linked in the body.

    Return type:

      None

  react(legacy_msg_id, emojis=(), thread=None, **kwargs)

    Send a reaction (XEP-0444) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – The message which the reaction refers to.

      - emojis (Iterable[str]) – An iterable of emojis used as reactions

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None

  retract(legacy_msg_id, thread=None, **kwargs)

    Send a message retraction (XEP-0424) from this XMPP Entity.

    Parameters:

      - legacy_msg_id (slidge.util.types.LegacyMessageType) – Legacy ID of the message to delete

      - thread (Optional[slidge.util.types.LegacyThreadType])

    Return type:

      None